import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class GameOver  extends Textfelder
{
    // Textfeld-Einstellungen
    public static final float FONT_SIZE = 60.0f;
    public static final int WIDTH = 500;
    public static final int HEIGHT = 500;
    public static final Color INNENFARBE = new Color(0, 63, 103, 100);
    public static final Color RAHMENFARBE = new Color(127, 127, 127, 100);
    
    //Standardkonstruktor fuer GameOver
    public GameOver() {
        this(1337);
    }
    
    // Bestimmter Konstruktor fuer GameOver
    // Aufgerufen von Glitschi
    public GameOver(int score) {        
        makeImage("Oh no!", "Glitschi died!", "Points: ", score);
    }

    // Macht das GreenfootImage
    private void makeImage(String title1, String title2, String prefix, int score) {
        GreenfootImage img = new GreenfootImage(WIDTH, HEIGHT);

        img.setColor(RAHMENFARBE);
        img.fillRect(0, 0, WIDTH, HEIGHT);
        img.setColor(INNENFARBE);
        img.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = img.getFont();
        font = font.deriveFont(FONT_SIZE);
        img.setFont(font);
        img.setColor(Color.WHITE);
        img.drawString(title1, 145, 150);
        img.setColor(new Color(200, 0, 0));
        img.getFont();
        font = font.deriveFont(FONT_SIZE + 10);
        img.setFont(font);
        img.drawString(title2, 30, img.getHeight() / 2);
        img.setColor(Color.WHITE);
        font = font.deriveFont(FONT_SIZE - 10);
        img.setFont(font);
        img.drawString(prefix + score, 135, 360);
        setImage(img);
    }
}
