import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class Laufzeitangabe  extends Textfelder
{
    public static final float FONT_SIZE = 40.0f;
    public static final int BREITE = 200;
    public static final int HOEHE = 110;
    public static final Color RAHMENFARBE = new Color(0, 63, 103);
    public static final Color INNENFARBE = new Color(0, 0, 0, 150);

    // Anzeigedauer um das Bild spaeter selbst zu removen
    public static int anzeigeDauer = 0;
    
    // Bestimmter Konstruktor fuer die Laufzeitangabe
     public Laufzeitangabe(int farbe, int plusminus, String punkte) {
        anzeigeDauer = 0;
        Color color = Color.WHITE;
        if (farbe == 1) {
            color = new Color(0, 255, 0, 100);
        }
        else {
            color = new Color(255, 0, 0, 100);
        }
        
        int schiebX = 0;
        String plus;
        
        if (plusminus == 0) {
            plus = "Oh no!";
            schiebX = 15;
        }
        else {
            plus = "Yeah!";
        }
        
        GreenfootImage lza = new GreenfootImage(BREITE, HOEHE);   
        
        lza.setColor(color);
        lza.fillRect(0, 0, BREITE, HOEHE);
        lza.setColor(INNENFARBE);
        lza.fillRect(5, 5, BREITE - 10, HOEHE - 10);
        Font font = lza.getFont();
        font = font.deriveFont(FONT_SIZE);
        lza.setFont(font);
        lza.setColor(color);
        lza.drawString(plus, 50 - schiebX, 50);
        lza.drawString(punkte, 70, 90);
        setImage(lza);
    }
    
    // Act-Methode fuer den Counter
    public void act() {
        anzeigeDauer++;
        removeMe();
    }
    
    // RemoveMe Methode zum automatischen Entfernen
    public void removeMe() {
        if (anzeigeDauer >= 100) {
            getWorld().removeObject(this);
        }
    }
    
    // Ausgabe der AnzeigeZeit
    public int getZeit() {
        return anzeigeDauer;
    }
}
