import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*; 
// import java.applet.Applet; // evt fuer Audio

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class Level  extends World
{
    // Spiel-Einstellungen
    public static final int SIZE = 600;
    private static final int ABSTAND_RECHTS = (SIZE - 100); // setzt getRandomNumber auf 500 (Spielgroesseabhaengig)
    private static final int ABSTAND_LINKS = (SIZE - ABSTAND_RECHTS) / 2; // entfernt von der Wand (links und oben)
    // Glitschi-Einstellungen
    public static final int GLITSCHI_START_X = 77;
    public static final int GLITSCHI_START_Y = 537;
    public static final int GLITSCHI_SCALING = 50;
    public static final int GLITSCHI_ROTATION = 315;
    public static final int STARTLEBEN = 3;
    public static final int STARTPUNKTE = 0;
    // Iglu-Einstellungen
    private static final int IGLU_ROTATION = 0;
    private static final int IGLU_HAUPTTEIL_POS_X = 54;
    private static final int IGLU_HAUPTTEIL_POS_Y = 553;
    private static final int IGLU_EINGANG_POS_X = 119;
    private static final int IGLU_EINGANG_POS_Y = 489;
    private static final int IGLU_BARRIERE_1_X = 49;
    private static final int IGLU_BARRIERE_1_Y= 466;
    private static final int IGLU_BARRIERE_2_X = 146;
    private static final int IGLU_BARRIERE_2_Y= 558;
    // Counter-Einstellungen
    private static final int LIVECOUNTER_X = 51;
    private static final int LIVECOUNTER_Y = 534;
    private static final int TRENNLINIE_X = 52;
    private static final int TRENNLINIE_Y = 550;
    private static final int PUNKTECOUNTER_X = 51;
    private static final int PUNKTECOUNTER_Y = 560;
    // Schnee-Einstellungen
    private static final int RAND_SCHNEE_X = 5;
    private static final int RAND_SCHNEE_X_LINKS = 0;
    private static final int RAND_SCHNEE_X_RECHTS = SIZE;
    private static final int RAND_SCHNEE_Y_OBEN = 0;
    private static final int RAND_SCHNEE_Y_UNTEN = SIZE;
    private static final int RAND_SCHNEE_SCALE = 50;
    // Fisch-Einstellungen
    private static final int FISCH_X = 450;
    private static final int FISCH_Y = 80;
    // Bilder einbinden
    GreenfootImage welcome = new GreenfootImage("WillkommensText.jpg");
    GreenfootImage ende = new GreenfootImage("EndeText.jpg");
    GreenfootImage levelBackground = new GreenfootImage("Eisdecke01.jpg");
    // Level-Informationen
    private int map = 0;
    
    // Standardkonstruktor fuer das Level (die Spielwelt)
    public Level() {    
        super(SIZE, SIZE, 1);  
        setWelcome();
    }
    
    // Willkommensbild
    public void setWelcome() {
        map = 0;
        setBackground(welcome); 
        addObject( new ClickBild(), SIZE / 2, SIZE / 2);
    }
    
    // gibSize Methode fuer z.B. das Textfeld
    public int gibSize() {
        return SIZE;
    }   
    
    // Alle Actors entfernen, Hintergrund setzen und Endbild ausgeben
    public void endBild() {        
        removeObjects(getObjects(Actor.class));
        
        setBackground(ende);
        Greenfoot.delay(300);
        Greenfoot.stop();

    }
    
    // Ausloeser: Glitschi - Programm wird gestoppt
    public void gameOverBild() {        
        if (map == 1) {   
            Greenfoot.delay(250);
            Greenfoot.stop();
        }
    }
    
    // Die Kulisse fuer das erste Level:
    // Enthaelt 4 Schnee (random), 4 Barrieren (random) , 1 Glitschi & 1 Iglu
    public void lvl1() {                 
        removeObjects(getObjects(Actor.class));
        Greenfoot.playSound("StartSound.wav");
        
        if (map != 1) {
            map = 1;
            setBackground(levelBackground);
            randSchnee();
            addSchnee();        
            addObject(new Fisch(), FISCH_X, FISCH_Y);
            addWasser();
            addOel();
            addIgluBarrieren();
            addObject(new Glitschi(GLITSCHI_SCALING, GLITSCHI_ROTATION, STARTLEBEN, STARTPUNKTE), GLITSCHI_START_X, GLITSCHI_START_Y);
            addObject(new IgluEingang(45), IGLU_EINGANG_POS_X, IGLU_EINGANG_POS_Y);
            addObject(new IgluHauptteil(), IGLU_HAUPTTEIL_POS_X, IGLU_HAUPTTEIL_POS_Y);        
            addObject(new Finish(), 51, 547);
            addObject(new Lives(STARTLEBEN), LIVECOUNTER_X, LIVECOUNTER_Y);
            addObject(new Trennlinie(), TRENNLINIE_X, TRENNLINIE_Y);
            addObject(new Punkte(), PUNKTECOUNTER_X, PUNKTECOUNTER_Y);
        }
    }
    
    // Erstellt Schnee am Rand des Levels, um Glitschi zu verlangsamen.
    public void randSchnee() {      
        // Schnee am oberen Rand
        for (int i = 0; i <= 15; i++) {
            addObject(new Randschnee(RAND_SCHNEE_SCALE), RAND_SCHNEE_X * (i*8), RAND_SCHNEE_Y_OBEN);
        }
        
        // Schnee am unteren Rand
        for (int i = 3; i <= 15; i++) {
            addObject(new Randschnee(RAND_SCHNEE_SCALE), RAND_SCHNEE_X * (i*8), RAND_SCHNEE_Y_UNTEN);
        }
        
        // Schnee am linken Rand
        for (int i = 1; i <= 13; i++) {
            addObject(new Randschnee(RAND_SCHNEE_SCALE), RAND_SCHNEE_X_LINKS, (RAND_SCHNEE_Y_OBEN + 5) * (i*8));
        }
        
        // Schnee am rechten Rand
        for (int i = 1; i <= 14; i++) {
            addObject(new Randschnee(RAND_SCHNEE_SCALE), RAND_SCHNEE_X_RECHTS, (RAND_SCHNEE_Y_OBEN + 5) * (i*8));
        }        
    }
    
    // Schnee wird hinzugefuegt, sofern er sich nicht an der Position des Iglus befindet.      
    public void addSchnee() {
        for (int i = 0; i < 4; i++) {
            int zufallszahlX = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
            int zufallszahlY = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
            
            // Schnee, der unter dem Iglu ist, wird nicht platziert.
            // Zaehler wird um 1 zurueckgesetzt und Aktion nochmals durchgefuehrt.
            if ((zufallszahlX < 80 ^ zufallszahlY > 450)) {
                i--;
            }
            else {
                addObject(new Schnee(), zufallszahlX + ABSTAND_LINKS, zufallszahlY + ABSTAND_LINKS);
            }
        }
    }
    
    // Barrieren am Eingang vom Iglu festlegen
    public void addIgluBarrieren() {
        addObject(new IgluBarriere(0), IGLU_BARRIERE_1_X, IGLU_BARRIERE_1_Y);
        addObject(new IgluBarriere(90), IGLU_BARRIERE_2_X, IGLU_BARRIERE_2_Y);
    }
  
    // Wasser hinzufuegen, sofern es nicht zu nahe am Iglu ist.
    public void addWasser() {
        for (int i = 0; i < 1; i++) {
        int zufallszahlX = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
        int zufallszahlY = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
        
        if ((zufallszahlX < 150 ^ zufallszahlY > 400)) {
                i--;
            }
            else {
                addObject(new Wasser(), zufallszahlX + ABSTAND_LINKS, zufallszahlY + ABSTAND_LINKS);
            }
        }        
    }
    
    // Oel hinzufuegen, sofern es nicht zu nahe am Iglu ist.
    public void addOel() {      
        for (int i = 0; i < 1; i++) {
        int zufallszahlX = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
        int zufallszahlY = Greenfoot.getRandomNumber(ABSTAND_RECHTS);
        
        if ((zufallszahlX < 150 ^ zufallszahlY > 400)) {
                i--;
            }
            else {
                addObject(new Oel(), zufallszahlX + ABSTAND_LINKS, zufallszahlY + ABSTAND_LINKS);
            }
        }        
    }
    
    // Neuen Fisch in die Welt setzen.
    public void giveFisch() {
        addObject(new Fisch(), Greenfoot.getRandomNumber(500) + 50, Greenfoot.getRandomNumber(200) + 50);
        // Abfrage wichtig, da falls kein Oel in der Welt ist, Fehler mit ArrayList kommt!
        if (getObjects(Oel.class).size() >= 1) {
            Oel oel = (Oel) getObjects(Oel.class).get(0);
            oel.setFischCounter();
        }
    }
}
