import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class Objekte  extends Actor
{
    private static final int RAND = 40;
    public static double moveSpeed;
    
    // Um einen bestimmten Winkel drehen.
    public void turn(int winkel) {
        setRotation(getRotation() + winkel);
    }
    
    // In die derzeitige Richtung bewegen.
    public void move(double speed) {
        moveSpeed = speed;
        
        double winkel = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(winkel) * moveSpeed);
        int y = (int) Math.round(getY() + Math.sin(winkel) * moveSpeed);
        
        setLocation(x, y);
    }
    
    // Ueberprueft, ob der Rand-Schnee erreicht wurde.
    public boolean randErreicht() {
        if(getX() < RAND || getX() > getWorld().getWidth() - RAND)
            return true;
        if(getY() < RAND || getY() > getWorld().getHeight() - RAND)
            return true;
        else
            return false;
    }
      
    // Ueberprueft ob ein Objekt einer bestimmten Klasse Kontakt hat.
    public boolean isHere(Class clss) {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
   
    // Laesst das Objekt, das mit dem entsprechenden Objekt Kontakt hat verschwinden.
    public void removeActor(Class clss) {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
}
