import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class Oel  extends Objekte
{
    // Counter-Einstellungen
    private static final int MAX_DREHCOUNTER = 30;   
    private static final int MAX_BILDERCOUNTER = 600;
    // diverse Datenfelder
    private double speed = 1.0;
    private double saveSpeed = 1.0;    
    private int drehCounter = 0;
    private boolean darfDrehen = true;
    private int bilderCounter = MAX_BILDERCOUNTER;
    private boolean getBild;
    private int fischCounter = 200;
    // Bilder vom Oel hier in Datenfeldern gespeichert
    GreenfootImage oel1 = new GreenfootImage("Oellache.png");
    GreenfootImage oel2 = new GreenfootImage("Oellache2.png");
    GreenfootImage oel3 = new GreenfootImage("Oellache3.png");
    GreenfootImage oel4 = new GreenfootImage("Oellache4.png");
    
    // Konstruktor mit zufaelliger Richtung des Objektes.
    public Oel() {
        setRotation(Greenfoot.getRandomNumber(179) + 1);
    }

    // Beim Hinzufuegen wird ueberprueft, ob das Iglu in Kontakt
    // mit diesem Objekt steht. Wenn ja, so wird das Objekt an eine sichere
    // Iglu-freie Zone gesetzt.    
    /**
     * funktioniert noch nicht so ganz ... Abfrage zu spaet. 
     * moegl. Loesung: Iglu durch das Oel erstellen lassen!
     * moegl. Loesung: genauere Koordinatenabfragen bei Schnee/Oel/Barriere einbauen!
     */
    public void addedToWorld(World Level) {
        int x = Greenfoot.getRandomNumber(600);
        int y = Greenfoot.getRandomNumber(300);
        
        Actor iglu = getOneIntersectingObject(Iglu.class);
        
        if (iglu != null) {
            setLocation(x, y);
        }  
    }
    
    // Act-Methode
    public void act() {
        checkDarfDrehen();
        randTurn();
        schneeTurn();
        igluTurn();
        bilderWechsel();
        drehCounter++;
        bilderCounter = bilderCounter - 4;
        move(speed); 
        checkWasser();
        checkFisch();
        fischCounter++;
    }    

    // Gibt momentane Geschwindigkeit zurueck.
    public double gibSpeed() {
        return speed;
    }      
    
    // Gibt den momentanen Wert von drehCounter zurueck.
    public int gibDrehCounter() {
        return drehCounter;
    }
    
    // Gibt den momentanen Wert von bilderCounter zurueck.
    public int gibBilderCounter() {
        return bilderCounter;
    }
    
    // Gibt den momentanen Wahrheitsgrad von darfDrehen zurueck.
    public boolean gibDarfDrehen() {
        return darfDrehen;
    }
    
    // Ueberprueft, ob gedreht werden darf
    public void checkDarfDrehen() {
        if (drehCounter >= MAX_DREHCOUNTER) {
            darfDrehen = true;
        }
        else {
            darfDrehen = false;
        }
    }        

    // Dreht bei Kontakt mit Schnee, sofern es drehen darf
    // setzt anschliessend den Counter auf 0
    public void schneeTurn() {
        if (isHere(Schnee.class) && darfDrehen) {
            turn(Greenfoot.getRandomNumber(45) - 90);
            speed = -speed;
            drehCounter = 0; 
        }                        
        /**if (isHere(Schnee.class) && !darfDrehen) {            
            double winkel = Math.toRadians(getRotation());
            
            int x = (int) Math.round(getX() + Math.cos(winkel) * speed);
            int y = (int) Math.round(getY() + Math.sin(winkel) * speed);                       
            setLocation(x, y);
        }*/
    }
    

    // Wird der Rand an einer bestimmten Stelle (oben, unten etc.) erreicht,
    // so wird das Objekt etwas weggesetzt und dessen Drehung geaendert.
    // Der drehCounter wird wieder auf 0 gesetzt.
    public void randTurn() {        
        // Warum ist die getRandomNumber-Funktion so bescheiden?! - Immer die gleichen Werte!!!
        int ausfallswinkel = (getRotation() - (Greenfoot.getRandomNumber(90) + 135));
        
        if (randErreicht() && getX() < 100) {
            setLocation(getX() + 10, getY());
            setRotation(ausfallswinkel);
            // turn(Greenfoot.getRandomNumber(180) - 90);
            // speed = -speed;
            drehCounter = 0;
        }
        if (randErreicht() && getX() > 500) {
            setLocation(getX() - 10, getY());
            setRotation(ausfallswinkel);
            // turn(Greenfoot.getRandomNumber(180) - 90);
            // speed = -speed;
            drehCounter = 0;
        }
        if (randErreicht() && getY() < 100) {
            setLocation(getX(), getY() + 10);
            setRotation(ausfallswinkel);
            // turn(Greenfoot.getRandomNumber(180) - 90);
            // speed = -speed;
            drehCounter = 0;
        }      
        if (randErreicht() && getY() > 500) {
            setLocation(getX(), getY() - 10);
            setRotation(ausfallswinkel);
            // turn(Greenfoot.getRandomNumber(180) - 90);
            // speed = -speed;
            drehCounter = 0;
        }               
    }
    
    // Wenn das Oel das Iglu beruehrt, dreht es (im Idealfall) ab.
    public void igluTurn() {
        int x = getX();
        int y = getY();
        
        if (isHere(Iglu.class)) {
            if (x < 135) {
                setLocation(x + 10, y);
                setRotation(getRotation()-180);
            }
            else {
                setLocation(x, y - 10);
                setRotation(getRotation()-180);
            }
        }
    }
    
    // Wechselt das Bild vom Oel, sodass es etwas animiert aussieht!
    // Tempo des Wechsels ist in der Act-Methode durch die bilderCounter-Veraenderung festgelegt.
    public void bilderWechsel() {
        if (bilderCounter > (MAX_BILDERCOUNTER - 100)) {
            setImage(oel1);
        }       
        if (bilderCounter > (MAX_BILDERCOUNTER - 200) && bilderCounter <= (MAX_BILDERCOUNTER - 100) ) {
            setImage(oel2);
        }        
        if (bilderCounter > (MAX_BILDERCOUNTER - 300) && bilderCounter <= (MAX_BILDERCOUNTER - 200)) {
            setImage(oel3);
        }                
        if (bilderCounter > (MAX_BILDERCOUNTER - 400) && bilderCounter <= (MAX_BILDERCOUNTER - 300)) {
            setImage(oel4);
        } 
        if (bilderCounter > (MAX_BILDERCOUNTER - 500) && bilderCounter <= (MAX_BILDERCOUNTER - 400)) {
            setImage(oel3);
        }
        if (bilderCounter > (MAX_BILDERCOUNTER - 600) && bilderCounter <= (MAX_BILDERCOUNTER - 500)) {
            setImage(oel2);
        }        
        if (bilderCounter <= 0) {
            setImage(oel1);
            bilderCounter = MAX_BILDERCOUNTER;
        }
    }    
    
    // Das Wasser teleportiert das Oel an eine beliebige Stelle
    public void checkWasser() {
        Wasser wasser = (Wasser) getOneObjectAtOffset(0, 0, Wasser.class);
        if (checkWasserKontakt() && Glitschi.wasserCounter >= 300) {
            wasser.teleportWasser();
            Greenfoot.playSound("WasserTp.wav");
            setLocation(wasser.wasserX(), wasser.wasserY());
            Glitschi.wasserCounter = 0;
        }
    }
    
    // Gibt einen Rueckgabewert, ob das Wasser-Objekt beruehrt wird.
    public boolean checkWasserKontakt() {
        Actor wasser = (Wasser) getOneObjectAtOffset(0, 0, Wasser.class);
        return wasser != null;
    }
    
    // Glitschi verliert einen Punkt, wenn das Oel den Fisch beruehrt.
    public void checkFisch() {
        Glitschi glitschi = (Glitschi) getWorld().getObjects(Glitschi.class).get(0);
        Fisch fisch = (Fisch) getOneObjectAtOffset(0, 0, Fisch.class);
        Level level = (Level) getWorld();
        if (checkFischKontakt() && fischCounter > 400) {
            getWorld().removeObject(fisch);
            glitschi.minusPunkt();
            level.giveFisch();
            setFischCounter();
            level.removeObject(this);
        }
    }
    
    // Methode um den Fischcounter zu setzen
    public void setFischCounter() {
        fischCounter = 0;
    }
    
    // Fischcounter ausgeben
    public int gibFischCounter() {
        return fischCounter;
    }
    
    // Gibt einen Rueckgabewert, ob das Fisch-Objekt beruehrt wird.
    public boolean checkFischKontakt() {
        Fisch fisch = (Fisch) getOneObjectAtOffset(0, 0, Fisch.class);
        return fisch != null;
    }
}

