import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * GetGlitschi
 * by D. Reichert
 * Version 1.0 on 27/02/2010
 * 
 * All graphics by D. Reichert
 */

public class Punkte  extends Textfelder
{
    private static final Color PUNKTECOLOR = Lives.LIVESCOLOR;
    private static final int FONTSIZE = Lives.FONTSIZE;   
    private static final int TEXTFELDBREITE = (FONTSIZE + 15);
    private static final int TEXTFELDHOEHE = (FONTSIZE + 5);

    public static int wert = 0;
    private String text = "P: ";
 
    // Standardkonstruktor fuer die Punkteanzeige
    public Punkte() {        
        GreenfootImage punkte = new GreenfootImage(TEXTFELDBREITE, TEXTFELDHOEHE);
        
        // lives.fill(); Hilsmethode um Groesse und Position anzupassen
        punkte.setColor(PUNKTECOLOR);
        Font font = new Font("Arial", Font.BOLD, FONTSIZE);
        punkte.setFont(font);
        punkte.drawString(text + wert, 1, 20);
        setImage(punkte);
    }  
    
    // Act-Methode um die Punkte abzufragen
    public void act() {
        getGlitschiPunkte();
    }
    
    // Fragt Glitschi nach dessen Punkte
    public void getGlitschiPunkte() {
        this.wert = Glitschi.getPunkte();
        addPunkte();
    }
    
    // Punkte adden
    public void addPunkte() {
        GreenfootImage punkte = getImage();
        
        if (wert < 5)
        {
            punkte.clear();
            punkte.drawString(text + wert, 1, 20);
            setImage(punkte);
        }
        else {            
            Level level = (Level) getWorld();      
            Greenfoot.playSound("GlitschiFanfare.wav");
            level.endBild();
        }
    }
    
    // Punkte ausgeben
    public int punkteStand() {
        return this.wert;
    }
}
